function [height, grid_controls] = draw_onto( object, parent_handle, grid, grid_controls, depth, start_height, x, y )
%DRAW_ONTO Draws the controls onto the parent_handle.  This function needs to be called everytime an update happens.
%   This function draws the entire handle onto the handle.  This function
%   needs to be called everytime the back table is updated.  The class will
%   notify when its necessary.

    if nargin == 2
        %Need to invert y, so need total size
        [x, y] = object.get_bounding_box();
        
        draw_onto(object, parent_handle, object.my_grid.grid, object.controls, 0, 0, x, y);
        
        
        %if ishandle(object.pb_delete)
        %    pb_delete = object.pb_delete;
        %else
            pb_delete = uicontrol(parent_handle, 'Style', 'pushbutton', 'String', 'Remove', 'Callback', @(src, event)object.my_grid.delete_cell([], object.my_grid.get_cell(object.my_grid.length) ) );
            %object.pb_delete = pb_delete;
        %end
       
        %if ishandle(object.pb_new)
        %    pb_new = object.pb_new;
        %else
            pb_new = uicontrol(parent_handle, 'Style', 'pushbutton', 'String', 'Add', 'Callback', @(src, event)object.my_grid.add_cell([], []));
        %    object.pb_new = pb_new;
        %end
        
        set(pb_delete, 'Position', [0, -20, 80, 20]);
        set(pb_new, 'Position', [0, -40, 80, 20]);
        
        return ;
    end

    % First delete an extra controls
    assert( ~(size(grid_controls, 2) > size(grid, 2)), 'Implment delete when necessary.');
    
    height = 0;
    
    for i = 1:size(grid, 2)
        if size(grid_controls, 2) >= i
            assert( false, 'Deal with existing controls' );
        else
            grid_controls{i} = struct();
            grid_controls{i}.subgrid = {};
            
            [new_height, grid_controls{i}.subgrid] = draw_onto( object, parent_handle, grid{i}.grid, grid_controls{i}.subgrid, depth+1, height, x, y);
            
            new_height = max([new_height 1]);
            height = height + new_height;

            %Kill the direct access here.
            str = grid{1}.get_user_string();
            
            uicontrol(parent_handle, 'Style', 'edit', 'Position', [depth*object.gui_params.edit_width, y-((height+start_height)*object.gui_params.edit_height), object.gui_params.edit_width, new_height*object.gui_params.edit_height], 'String', str, 'Callback', @(src,event)GUIHelpers.update_cell(src, event, grid{i}));
            
        end
    end

end

